-- if things seem odd you can adjust here

-- scale of action bars
local SCALE = 0.78125 -- 0.5 / 0.64

-- height of exp and rep bars
local HEIGHT = 4

-- fade micro buttons and bags
local FADE_BOX = 1

-- end of config



do	
	-- two rows MultiBarBottomRight
	MultiBarBottomRightButton7:ClearAllPoints()
	MultiBarBottomRightButton7:SetPoint("BOTTOMLEFT", ActionButton12, "BOTTOMRIGHT", 12, 0)

	-- adjusts MultiBarRight and MultiBarLeft
	-- MultiBarRightButton1:ClearAllPoints()
	-- MultiBarRightButton1:SetPoint("TOPRIGHT", MultiBarRight, x, y)
	-- MultiBarLeftButton1:ClearAllPoints()
	-- MultiBarLeftButton1:SetPoint("TOPRIGHT", MultiBarLeft, x, y)

	-- PetActionButtons on the right side
	PetActionButton1:ClearAllPoints()
	PetActionButton1:SetPoint("BOTTOMLEFT", MultiBarBottomRightButton6, "TOPRIGHT", -404, 5) -- 372 + 32

	-- concerned things with MainMenuBar
	MainMenuExpBar:SetWidth(761)
	MainMenuExpBar:SetHeight(HEIGHT)
	MainMenuExpBar:ClearAllPoints()
	MainMenuExpBar:SetPoint("CENTER", MainMenuBar, "TOP", 0, -4.5)

	local fontFile, fontHeight, fontFlags = MainMenuBarExpText:GetFont()
	MainMenuBarExpText:SetFont(fontFile, floor(fontHeight / SCALE + 0.5), fontFlags)

	ExhaustionLevelFillBar:SetHeight(HEIGHT)

	ReputationWatchBar:SetWidth(761)
	ReputationWatchBar:SetHeight(HEIGHT)

	ReputationWatchStatusBar:SetWidth(761)

	local fontFile, fontHeight, fontFlags = ReputationWatchStatusBarText:GetFont()
	ReputationWatchStatusBarText:SetFont(fontFile, floor(fontHeight / SCALE + 0.5), fontFlags)

	-- re-reconfigure ReputationWatchBar
	-- we can't use events because of the delay issue
	local function ReputationWatchBar_Update_posthook(...)
		local name, reaction, _, _, value = GetWatchedFactionInfo()
		local hasExpBar = MainMenuExpBar:IsShown()

		if ( not name ) then
			if ( hasExpBar and MainMenuBarExpText:GetPoint() ~= "CENTER" ) then
				MainMenuBarExpText:ClearAllPoints()
				MainMenuBarExpText:SetPoint("CENTER", MainMenuExpBar, 0, 1)
			end

			return ...
		end

		ReputationWatchStatusBar:SetHeight(HEIGHT)
		ReputationWatchStatusBarText:SetText(ReputationWatchStatusBarText:GetText() .. " " .. GetText("FACTION_STANDING_LABEL" .. reaction, UnitSex("player"))) -- adds standing label

		if ( hasExpBar ) then
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("CENTER", MainMenuBar, "TOP", 0, 4.5)

			if ( ReputationWatchStatusBarText:GetPoint() ~= "RIGHT" ) then
				ReputationWatchStatusBarText:ClearAllPoints()
				ReputationWatchStatusBarText:SetPoint("RIGHT", ReputationWatchBarOverlayFrame, -128, 1)
			end

			if ( MainMenuBarExpText:GetPoint() ~= "LEFT" ) then
				MainMenuBarExpText:ClearAllPoints()
				MainMenuBarExpText:SetPoint("LEFT", MainMenuExpBar, 128, 1)
			end
		else
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("CENTER", MainMenuBar, "TOP", 0, -4.5)

			if ( ReputationWatchStatusBarText:GetPoint() ~= "CENTER" ) then
				ReputationWatchStatusBarText:ClearAllPoints()
				ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, 0, 1)
			end
		end

		-- removes watched faction if we ware exalted
		if ( value == 42999 ) then
			SetWatchedFactionIndex(0)
		end

		return ...
	end
	local ReputationWatchBar_Update_original = ReputationWatchBar_Update
	function ReputationWatchBar_Update(...)
		return ReputationWatchBar_Update_posthook(ReputationWatchBar_Update_original(...))
	end

	-- actual new MainMenuBar's width
	MainMenuBar:SetWidth(777) -- 761 + 8 * 2
	-- who cares? but i do
	MainMenuBar:EnableMouse(false)


	-- unloads un-wanted textures
	for _, texture in next, {
		MainMenuXPBarTextureLeftCap,MainMenuXPBarTextureRightCap,MainMenuXPBarTextureMid, MainMenuMaxLevelBar0, MainMenuMaxLevelBar1, MainMenuMaxLevelBar2, MainMenuMaxLevelBar3, MainMenuBarTexture0, MainMenuBarTexture1, --[[MainMenuBarTexture2, MainMenuBarTexture3,]] MainMenuBarLeftEndCap, MainMenuBarRightEndCap,
		ReputationWatchBarTexture0, ReputationWatchBarTexture1, ReputationWatchBarTexture2, ReputationWatchBarTexture3, ReputationXPBarTexture0, ReputationXPBarTexture1, ReputationXPBarTexture2, ReputationXPBarTexture3,
		BonusActionBarTexture0, BonusActionBarTexture1, ShapeshiftBarLeft, ShapeshiftBarMiddle, ShapeshiftBarRight, PossessBackground1, PossessBackground2,
		SlidingActionBarTexture0, SlidingActionBarTexture1,
	} do
		texture:SetTexture(nil)
	end
	
	-- scales these bars
	for _, bar in next, {
		MainMenuBar, --[[ VehicleMenuBar,]] MultiBarRight
	} do
		bar:SetScale(SCALE)
	end

end




-- modified by smaltore @2011-11-16
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
	
	--hide petbar when vehicle showing
	local petframe = CreateFrame("frame", "petfrme_event", MainMenuBar)
	PetActionBarFrame:SetParent( petframe )
	RegisterStateDriver(petframe, "visibility", "[target=vehicle,exists] hide;show")
	
	MainMenuBarArtFrame:UnregisterAllEvents()
	VehicleMenuBar:UnregisterAllEvents()
	
	-- hide the art frames from bonus action bar
	hooksecurefunc("UIParent_ManageFramePosition", function ()
		BonusActionBarFrameTexture1:SetTexture(nil);         --hide arts from bonus bar
		BonusActionBarFrameTexture2:SetTexture(nil);
		for _,frame in next, {
			MainMenuBarTexture0,MainMenuBarTexture1,--
			MainMenuBarTexture2,MainMenuBarTexture3, --Կ׺ͱ
			MainMenuBarLeftEndCap, MainMenuBarRightEndCap, --˵ӥ
			MainMenuBarPageNumber,ActionBarUpButton,ActionBarDownButton, --ҳť
			} 
		do	frame:Hide()	end
	
		for i=1,19 do _G["MainMenuXPBarDiv"..i]:SetTexture(Empty_Art) end	--ĸ 
		
	end)
-------------------------------------bags and micro menu----------------------------------
	--create fade function 
	function fade(frame,button)
		local function showhide(alpha)
			frame:SetAlpha(alpha)
		end
		frame:EnableMouse(true)
		frame:SetAlpha(0.1)
		frame:SetScript("OnEnter", function(self) showhide(1) end)
		frame:SetScript("OnLeave", function(self) showhide(0.1) end)
		button:HookScript("OnEnter", function(self) showhide(1) end)
		button:HookScript("OnLeave", function(self) showhide(0.1) end)
	end

	--bags and micromenu buttons
	local MicroButtons = {	
		CharacterMicroButton,
		SpellbookMicroButton,
		TalentMicroButton,
		AchievementMicroButton,
		QuestLogMicroButton,
		GuildMicroButton,
		PVPMicroButton,
		LFDMicroButton,
		EJMicroButton,
		RaidMicroButton,
		MainMenuMicroButton,
		HelpMicroButton,
	}
	local BagButtons = { 
		MainMenuBarBackpackButton,
		CharacterBag0Slot,
		CharacterBag1Slot,	
		CharacterBag2Slot,
		CharacterBag3Slot,
		--KeyRingButton
	}
	
	local box = CreateFrame("Frame","Micro_and_Bags_Frame",UIParent)
		box:SetWidth(210)
		box:SetHeight(55)
		box:SetPoint("BOTTOMRIGHT", UIParent, 0, 0);
		box:SetScale(SCALE * 0.8)
	local function mybox()
		--bags
		for _, button in pairs(BagButtons) do
			if button ~= MainMenuBarBackpackButton then
				button:Hide()
			else
				MainMenuBarBackpackButton:SetParent(box)
				MainMenuBarBackpackButton:SetScale( 2.2 )
			end
		end
		MainMenuBarBackpackButton:ClearAllPoints();
		MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT",box,0,0);
		-- micro menu bar ϵͳ˵
		for _, button in pairs(MicroButtons) do
			button:SetParent(box);
		end
		CharacterMicroButton:ClearAllPoints();
		CharacterMicroButton:SetPoint("BOTTOMLEFT", MainMenuBarBackpackButton, -155, 30);
		PVPMicroButton:ClearAllPoints();
		PVPMicroButton:SetPoint("TOPLEFT", CharacterMicroButton, "BOTTOMLEFT", 0, 25);
	end
	mybox()
	hooksecurefunc("UpdateMicroButtons",mybox)
	
	--fade and move the side bars
	if FADE_BOX == 1 then 
		for _,button in pairs(MicroButtons) do fade(box,button) end
		for _,button in pairs(BagButtons) 	do fade(box,button) end
	end
	
	
	
	--------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------
	--patch from Tidy bar
	--fix pet bar bug, it doesn't show sometime
	PetActionBarFrame:SetAttribute("unit", "pet")    
	RegisterUnitWatch(PetActionBarFrame)

	
	--------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------
	--patch from rActionBarStyler
	--unable the vehiclemenubar from the blliz, and make the action buttons from vehiclemenubar show on mainmenubar 

	hooksecurefunc('TalentFrame_LoadUI', function()
		PlayerTalentFrame:UnregisterEvent('ACTIVE_TALENT_GROUP_CHANGED')	end)

	local mainnenubar = CreateFrame("Frame","lucidity_plus_MainMenuBar",UIParent, "SecureHandlerStateTemplate")

	mainnenubar:RegisterEvent("PLAYER_LOGIN")
	mainnenubar:RegisterEvent("KNOWN_CURRENCY_TYPES_UPDATE")
	mainnenubar:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
	mainnenubar:RegisterEvent("BAG_UPDATE")
	mainnenubar:RegisterEvent("PLAYER_TARGET_CHANGED");
	mainnenubar:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_LOGIN" then
		local button, buttons
		for i = 1, NUM_ACTIONBAR_BUTTONS do
			button = _G["ActionButton"..i]
			self:SetFrameRef("ActionButton"..i, button)
		end

		self:Execute([[
			buttons = table.new()
			for i = 1, 12 do
				table.insert(buttons, self:GetFrameRef("ActionButton"..i))
			end
		]])

		self:SetAttribute("_onstate-page", [[
			for i, button in ipairs(buttons) do
				button:SetAttribute("actionpage", tonumber(newstate))
			end
		]])

		RegisterStateDriver(self, "page", "[bonusbar:5] 11; [bar:2] 2; [bar:3] 3; [bar:4] 4; [bar:5] 5; [bar:6] 6;")
	elseif event == "PLAYER_TARGET_CHANGED" then
		--if agr = 
		
	else
		MainMenuBar_OnEvent(self, event, ...)
	end
	end)